Subject: Re: Bug#657390: lintian: Please make build-arch and build-indep required targets

From: Guillem Jover <[email-masked]>
Date: Wed, 28 Aug 2013 04:28:07 +0200

Hi!

On Mon, 2013-08-26 at 09:58:33 +0200, Niels Thykier wrote:
> At March 1st, we had 3630 packages missing at least one recommended
> target according to Lintian.  Yesterday, the number was 3122.  Both
> numbers include source packages in sid and in experimental, so it may be
> slightly inflated[1].
>   The change translates to about 85 packages a month are being
> "fixed"[2], but our graph suggests that somewhere between May and July
> the rate increased[3].  Indeed, for the last month, a total of 96 (~3 a
> day) were "fixed".
>   If the current rate is sustained, we are looking at ~3 years for this
> problem to fix itself.  Even if we assume 10% of these to only affect
> experimental (see [1]) and all fixes affect sid, we are still look at
> ~2.5 years.

Well, if we take into account the dynamics of normal transitions the
remaining long tail usually takes a very long time to get done w/o
active incentives.

I've been passively tracking the Source-Version substvar migration
since around 2007, out of curiosity on how this kind of migrations
go w/o any active external intervention (just as an observer), which
I'll try to post on -devel at some point, but in any case the first
year around 900~ packages got fixed, next year 190~, then 110~, 30~,
15~, and a year up to now 3. I doubt the remaning 43 packages will get
fixed soon (as in 1-2 years) if no MBF or possibly NMUs are performed.

> On 2013-01-24 23:13, Roger Leigh wrote:
> > On Wed, Jan 23, 2013 at 04:46:06AM +0100, Guillem Jover wrote:
> > [...]
> >> I think the less painful way to achieve that would be by a staged
> >> increase of the enforcing level of those targets, where changing dpkg
> >> to require them should be the last stage when really few packages
> >> still do not provide it, because otherwise mass rebuilds, binNMUs and
> >> similar become very painful.
> >> 	
> >> The first stage could be to wait a bit after testing thaws to see the
> >> progress; after a bit, change/rename the tag to an error w/o autoreject.
> >> Wait and see how it progresses, and after a bit more (several months)
> >> change it to autoreject, but not for binNMUs if that's possible? to
> >> avoid disrupting the release process. And then only a small tail
> >> should remain which could be handled by a MBF etc. After or during
> >> this last stage dpkg could be switched.
> > 
> > I think this all makes a good deal of sense.  It's certainly
> > logistically impractical to "force" the issue by changing dpkg until
> > the vast majority of packages are converted, so we certainly need to
> > encourage adoption by other means and do this as the final step.
> 
> So, the question is now - do we want to scale up the enforcement level,
> and, if so, to what?  As mentioned earlier, I am willing to increase the
> severity of the tag (provided it does not become an auto-reject overnight).

I think if we'd want to get this done relatively soon, then it needs
“active herding”. Increasing the lintian tag to a non auto-reject error,
mails to debian-devel (or d-d-a) and possibly blog posts encouraging
people to switch packages, someone to possibly handle it as a release
goal to give it visibility, etc.

After a while, and depending on the amount still remaning, probably
switching to more aggressive methods, like I described above would
help with the remaining straddlers.

Thanks,
Guillem